package sequenze;
import java.util.NoSuchElementException;

public class LinkedSeqIterator<T>
implements SeqIterator<T>
{
	LinkedSequenza<T> ls;
	NodoDoppio<T> cursore;
	int index = 0;

	LinkedSeqIterator(LinkedSequenza theLS)
	{
		ls = theLS;
		cursore = ls.head;
	}

	public boolean hasNext()
	{
		return (cursore != null);
	}

	public T next()
	{
		if(cursore == null)
		{
			throw new NoSuchElementException();
		}
		index++;
		T retval = cursore.contenuto;
		cursore = cursore.next;
		return retval;
	}

	public int nextIndex()
	{
		return index;
	}
}
