public class SeqIterator<T>
{
	private Sequenza<T> mySeq;
	private int pos;

	public SeqIterator(Sequenza<T> s)
	{
		mySeq = s;
		pos = 0;
	}

	public boolean hasNext()
	{
		return (pos >= 0 && pos < mySeq.size());
	}

	public T next()
	{
		return mySeq.get(pos++);
	}

	public int nextIndex()
	{
		return pos;
	}
}
