package composite.fatturato;

import java.util.List;

public class PuzzaDiPrimavera
implements SaponeProfumato
{
	double fatturato = 0.0;

	public double getFatturato()
	{
		return fatturato;
	}

	public boolean isLeaf()
	{
		return true;
	}

	public boolean isComposite()
	{
		return !isLeaf();
	}

	public List<? extends Fatturabile> getChildren()// if(isLeaf()) return null;
	{
		return null;
	}

	public double addFatturato(double f)
	{
		double retval = fatturato;
		fatturato += f;
		return retval;
	}
}
