package sequenze;

public class ArraySeqIterator<T>
implements SeqIterator
{
	private Sequenza<T> mySeq;
	private int pos;

	public ArraySeqIterator(Sequenza<T> s)
	{
		mySeq = s;
		pos = 0;
	}

	public boolean hasNext()
	{
		return (pos >= 0 && pos < mySeq.size());
	}

	public T next()
	{
		return mySeq.get(pos++);
	}

	public int nextIndex()
	{
		return pos;
	}
}
