package tree;

import java.io.*;

public class OrderedTree
{
	public static void main(String[] argv)
	{
		BinTreeNode<Integer> root = null;

		BufferedReader br = null;
		br = new BufferedReader(new InputStreamReader(System.in));

		String line = null;
		try
		{
			while( (line = br.readLine())!= null)
			{
				Integer i = new Integer(line);
				BinTreeNode<Integer> tmp = root;
				if(tmp == null)//albero vuoto
				{
					root = new BinTreeNode<Integer>(i);
					continue;
				}

				while(true)
				{
					if(i.compareTo(tmp.getValue()) >= 0)
					{
						if(tmp.getRightChild() == null)
						{
							//non ho nessun figlio di destra, ci metto il nuovo nodo
							tmp.setRightChild(new BinTreeNode<Integer>(i));
							break;
						}
						tmp = tmp.getRightChild();
					}
					else
					{
						if(tmp.getLeftChild() == null)
						{
							//non ho nessun figlio di sinistra, ci metto il nuovo nodo
							tmp.setLeftChild(new BinTreeNode<Integer>(i));
							break;
						}
						tmp = tmp.getLeftChild();
					}
				}
			}

			//albero creato con valori ordinati
			root.printInOrder();
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
	}
}
